#!/usr/bin/env python3

# Python fft component map creator
#
# This file is protected by Copyright. Please refer to the COPYRIGHT file
# distributed with this source distribution.
#
# This file is part of OpenCPI <http://www.opencpi.org>
#
# OpenCPI is free software: you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
# more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

"""Script to generate FFT entity mappings.

This takes incoming coefficient files, and generates a VHDL generate mapper,
allowing the selection of the correct FFT instance, from a generic.
"""

import argparse
from datetime import datetime
import numpy as np
import logging
from os.path import basename, splitext


def parse_file_header(file):
    """Parse hex file header.

    Args:
        file (Pathlike): file to parse.

    Returns:
        dict: Dictionary containing information from the file header.
    """
    fields = ["Stage", "Bits", "NWide", "Offset", "Inv"]
    field_type = {"Stage": int, "Bits": int,
                  "NWide": int, "Offset": int, "Inv": bool}

    file_dict = {}
    with file as f:
        file_dict["Name"] = basename(file.name)
        for line in f.readlines():
            for field in fields:
                if field in line:
                    logging.debug(f"Found field \"{field}\" in line: {line}")
                    file_dict[field] = field_type[field](
                        line.partition(":")[-1].split()[0])
    return file_dict


def parse_hex_file_body(file):
    """Parse hex file coefficients (file body).

    Args:
        file (Pathlike): file to parse.

    Returns:
        list: Array of data from file.
    """
    data = []
    if file.closed:
        file = open(file.name, "r")
    with file as f:
        for line in f:
            if line.startswith("//"):
                continue
            data.append(line.strip())
    return data


def parse_files(input_files, output_file):
    """Parse files from hex coefficients to verilog headers.

    Args:
        input_files (list): List of files.
        output_file (pathlike): file to save all coefficients into.
    """
    with arguments.output_file as o:
        for f in arguments.input_files:
            logging.info(f"Parsing file: {f.name}")
            coeffs = parse_file_header(f)
            coeffs["data"] = parse_hex_file_body(f)

            o.write("localparam [0:{0}] {1} = {{\n".format(
                (2 * coeffs["Bits"] * len(coeffs["data"])) - 1,
                splitext(coeffs["Name"])[0]
            ))
            for d in coeffs["data"][:-1]:
                o.write("  {}'h{}, \n".format(2*coeffs["Bits"], d))
            o.write("  {}'h{}\n".format(2*coeffs["Bits"], coeffs["data"][-1]))
            o.write("};\n")


def add_entity(input_width, output_stream):
    """Adds an entity section to the requested file.

    Args:
        input_width (int): Width of the input data port.
        output_stream (stream_handle): Stream to write changes to.
    """
    output_stream.write(
        """-- Fast Fourier Transform Mapping to FFT cores
--
-- THIS FILE WAS AUTOGENERATED ON {}, AND MIGHT BE OVERWRITTEN

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.math_real.all;

library ocpi;
use ocpi.types.all;  -- remove this to avoid all ocpi name collisions
entity fast_fourier_transform_map is
  generic (
    fft_length_g  : positive;
    inverse_fft_g : boolean;
    input_width_g : natural := {}
    );
  port (
    clk         : in  std_logic;
    reset       : in  std_logic;
    enable      : in  std_logic;
    input_data  : in  std_logic_vector((2*input_width_g)-1 downto 0);
    output_data : out std_logic_vector((input_width_g + (integer(log2(real(fft_length_g)))/2) + 1)*2-1 downto 0);
    output_0bin : out std_logic
    );
end entity;
""".format(str(datetime.today()), input_width))


def add_component_definition(name, input_width, fft_length):
    """Generate a single component clause.

    Args:
        name (str): Name of the component.
        input_width (int): Width of the input data port.
        fft_length (int): FFT length of this component.

    Returns:
        str: populated component definition.
    """
    input_length = int(input_width*2)-1
    output_length = int((input_width + int(np.log2(fft_length)/2) + 1)*2-1)
    return """
    component {0}
    port (
      i_clk    : in  std_logic;
      i_reset  : in  std_logic;
      i_ce     : in  std_logic;
      i_sample : in  std_logic_vector({1} downto 0);
      o_result : out std_logic_vector({2} downto 0);
      o_sync   : out std_logic
      );
    end component;
""".format(name, input_length, output_length)


def add_component_declaration(fft_length):
    """Generate a pair of component maps.

    Args:
        fft_length (int): FFT length of this component.

    Returns:
        str: populated component declaration.
    """
    return """
  fft_{0}_gen : if fft_length_g = {0} generate
    forward_gen : if not inverse_fft_g generate
      fft_i : fftmain_{0}
        port map (
          i_clk    => clk,
          i_reset  => reset,
          i_ce     => enable,
          i_sample => input_data,
          o_result => output_data,
          o_sync   => output_0bin
          );
    end generate;
    inverse_gen : if inverse_fft_g generate
      fft_i : ifftmain_{0}
        port map (
          i_clk    => clk,
          i_reset  => reset,
          i_ce     => enable,
          i_sample => input_data,
          o_result => output_data,
          o_sync   => output_0bin
          );
    end generate;
  end generate;
""".format(fft_length)


def add_architecture(input_width, fft_lengths, output_stream):
    """Generate VHDL architecture.

    Args:
        input_width (int): Width of the input data port.
        fft_lengths (list): FFT lengths to include FFTs for.
        output_stream (stream_handle): Stream to write changes to.
    """
    output_stream.write("architecture rtl of fast_fourier_transform_map is")
    for fft in fft_lengths:
        output_stream.write(add_component_definition(
            f"fftmain_{fft}", input_width, fft))
        output_stream.write(add_component_definition(
            f"ifftmain_{fft}", input_width, fft))

    output_stream.write("begin")
    for fft in fft_lengths:
        output_stream.write(add_component_declaration(fft))

    # Add catch all others
    output_stream.write(
        f"fft_not_known_gen : if fft_length_g /= {fft_lengths[0]}")
    for fft in fft_lengths[1:]:
        output_stream.write(f"\nand fft_length_g /= {fft}")
    output_stream.write("""
  generate
    constant fail_divide : integer := 1/0;
  begin
    output_0bin <= '0';
  end generate;
end rtl;
""")


if __name__ == "__main__":
    parser = argparse.ArgumentParser(
        description="Converts multiple hex files into a verilog header file")
    parser.add_argument("-v", "--verbose", action="store_true",
                        help="Print additional logging")
    parser.add_argument("-w", "--input_width", default=16, type=int,
                        help="Input width for FFT components")
    parser.add_argument("-o", "--output_file", type=argparse.FileType("w", encoding="UTF-8"),
                        default="fft_map.vhd",
                        help="File path for the verilog header file (.vh extension)")

    parser.add_argument("fft_lengths",
                        type=int,
                        nargs="+",
                        help="FFT Lengths which need including")
    arguments = parser.parse_args()

    if arguments.verbose:
        logging.basicConfig(level="DEBUG")
    else:
        logging.basicConfig(level="WARNING")

    logging.debug(f"Saving output data to: {arguments.output_file}")
    logging.info(f"Creating {len(arguments.fft_lengths) * 2} components")
    with arguments.output_file as o:
        add_entity(arguments.input_width, o)
        add_architecture(arguments.input_width, arguments.fft_lengths, o)
